package proxyinvoker;

import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Method;
import java.lang.reflect.Proxy;

/**
 * 
 * @author Antonio Kantek
 */
public class InvokerHandler implements InvocationHandler {

	private Invoker invoker;
	
	private String objectName;

	public InvokerHandler(String objectName, Invoker invoker) {
		this.invoker = invoker;
		this.objectName = objectName;
	}

	public Object invoke(Object proxy, Method m, Object[] params) throws Throwable {
		try {  
			return invoker.invoke(new Invocation(this.objectName, m.getName(), m.getParameterTypes(), params));
		} catch (Exception ex) {
			ex.printStackTrace();
			throw new RuntimeException(ex.getMessage());
		}
	}
}
