package proxyinvoker;

import java.io.ObjectInput;
import java.io.ObjectInputStream;
import java.io.ObjectOutput;
import java.io.ObjectOutputStream;
import java.net.ServerSocket;
import java.net.Socket;

/**
 * 
 * @author Antonio Kantek
 */
public class InvokerSkeleton implements Runnable {
	
	private int port;
	
	private boolean running;
	
	private Invoker invoker;

	public InvokerSkeleton(int port, Invoker invoker) {
		this.port = port;
		this.running = true;
		this.invoker = invoker;
	}

	/**
	 * @see java.lang.Runnable#run()
	 */
	public void run() {
		try {
			ServerSocket server = new ServerSocket(this.port);
			while (this.running) {
				Socket socket = server.accept();
				ObjectInput in = new ObjectInputStream( socket.getInputStream() );
				Invocation inv = (Invocation)in.readObject();
				Object result = this.invoker.invoke(inv);
				ObjectOutput out = new ObjectOutputStream( socket.getOutputStream() );
				out.writeObject(result);
				out.flush();
				in.close();
				out.close();
				socket.close();
			}
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

}
