package proxyinvoker;

import java.io.ObjectInput;
import java.io.ObjectInputStream;
import java.io.ObjectOutput;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.rmi.RemoteException;

/**
 * 
 * @author Antonio Kantek
 */
public class InvokerStub implements Invoker {
 
	private String host;
	
	private int port;
 
	public InvokerStub(String host, int port) {
		this.host = host;
		this.port = port;
	}

	/**
	 * @see proxyinvoker.Invoker#invoke(Invocation)
	 */
	public Object invoke(Invocation inv) {
		try {
			Socket socket = new Socket(this.host, this.port);
			ObjectOutput out = new ObjectOutputStream( socket.getOutputStream() );
			out.writeObject(inv);
			ObjectInput in = new ObjectInputStream( socket.getInputStream() );
			Object result = in.readObject();
			in.close();
			out.flush();
			out.close();
			socket.close();
			return result;
		} catch (Exception ex) {
			throw new RuntimeException(ex.getMessage());
		}
	}

}
